#ifndef DEPRESSION_H
#define DEPRESSION_H

#include <vector>
#include <algorithm>
#include <iostream>
#include "MersenneTwister.h"
using namespace std;


// global variables

#define fichierLecture "parametres.txt"     // names of input 
#define fichierEcriture "resultats.txt"		// and output files

// definition of structure "chr" representing a chromosome:
// "mod" is the allele at the modifier locus (here the selfing rate coded by the modifier allele),
// "sel" is a vector containing the positions of deleterious alleles along the chromosome

struct chr
{
	double mod; // modifier locus
	int nHe;
	vector<double> sel; // selected loci
};



// Prototypes of functions

void ouvrirFichierE();
void ouvrirFichierS();
void ecrireParametres(int Nv, double av, double rhov, double sv, double hv, double eaav, double eadv, double eddv, 
			double Uv, double Lv, double mutMv, double mutMstepv, int NbPrelimv, int NbGenv, int pasprv, 
			int pasv, int sampleSv);
bool lireFichier(int &Nr, double &ar, double &rhor, double &sr, double &hr, double &eaar, double &eadr, double &eddr, 
		double &Ur, double &Lr, double &mutMr, double &mutMstepr, int &NbPrelimr, int &NbGenr, int &pasprr, 
		int &pasr, int &sampleSr) ;
void recursion(int Nv, double av, double rhov, double sv, double hv, double eaav, double eadv, double eddv, 
		double Uv, double Lv, double mutMv, double mutMstepv, int NbPrelimv, int NbGenv, int pasprv, 
		int pasv, int sampleSv, int nov);
double gammln(const double xx);
double poisdev(const double xm);
double binldev(const double pp, const int n);
double fitness(chr &c1, chr &c2, double wHe, double wHo, double wAA, double wAD, double wDD);
void rec(chr &res, chr &c1, chr &c2, double sz);
double gasdev();

#endif
