// Functions to open input and output files, 
// read parameter values and write them in output file

#include "depression.h"
#include <iostream>
#include <fstream>
using namespace std;

extern FILE * fichierE;
extern FILE * fichierS;


//Opens input file:

void ouvrirFichierE()    
{						 
	fichierE = fopen(fichierLecture,"r");
	if (!fichierE)
		cout << "The file " << fichierLecture 
			 << " doesn't exist!\n\n";
}



//Opens output file:

void ouvrirFichierS() 
{
	fichierS = fopen(fichierEcriture,"a");
	if (!fichierS)
		cout << "Impossible to open " << fichierEcriture << " !\n\n";
}



// Reads parameter values from input file,
// returns 1 if it reaches the end of input file, else returns 0:

bool lireFichier(int &Nr, double &ar, double &rhor, double &sr, double &hr, double &eaar, double &eadr, double &eddr, 
		double &Ur, double &Lr, double &mutMr, double &mutMstepr, int &NbPrelimr, int &NbGenr, int &pasprr, 
		int &pasr, int &sampleSr)   
					 
{					 
	int x;
	bool term;
	do {x = fgetc(fichierE);} while (!((x == '*') || (x == EOF)));
		// Lines with parameter sets must begin with *
	if (x == EOF)
	{
		cout << "\nEnd of input file\n";
		term = true;
	}
	else
	{
		fscanf(fichierE,"%d ",&Nr);
		fscanf(fichierE,"%lf ",&ar);
		fscanf(fichierE,"%lf ",&rhor);
		fscanf(fichierE,"%lf ",&sr);
		fscanf(fichierE,"%lf ",&hr);
		fscanf(fichierE,"%lf ",&eaar);
		fscanf(fichierE,"%lf ",&eadr);
		fscanf(fichierE,"%lf ",&eddr);
		fscanf(fichierE,"%lf ",&Ur);
		fscanf(fichierE,"%lf ",&Lr);
		fscanf(fichierE,"%lf ",&mutMr);
		fscanf(fichierE,"%lf ",&mutMstepr);
		fscanf(fichierE,"%d ",&NbPrelimr);
		fscanf(fichierE,"%d ",&NbGenr);
		fscanf(fichierE,"%d ",&pasprr);
		fscanf(fichierE,"%d ",&pasr);
		fscanf(fichierE,"%d ",&sampleSr);
		
		term = false;
	} 
	return term;
}



//Writes parameter values in output file:

void ecrireParametres(int Nv, double av, double rhov, double sv, double hv, double eaav, double eadv, double eddv, 
			double Uv, double Lv, double mutMv, double mutMstepv, int NbPrelimv, int NbGenv, int pasprv, 
			int pasv, int sampleSv)   
{
	fprintf(fichierS,"\n_________________________________________\n");
	fprintf(fichierS,"\nN = %d", Nv);
	fprintf(fichierS,", a = %g", av);
	fprintf(fichierS,", rho = %g", rhov);
	fprintf(fichierS,", s = %g", sv);
	fprintf(fichierS,", h = %g", hv);
	fprintf(fichierS,", eaa = %g", eaav);
	fprintf(fichierS,", ead = %g", eadv);
	fprintf(fichierS,", edd = %g", eddv);
	fprintf(fichierS,", U = %g", Uv);
	fprintf(fichierS,", L = %g", Lv);
	fprintf(fichierS,"\nmutM = %g", mutMv);
	fprintf(fichierS,", mutMstep = %g", mutMstepv);
	fprintf(fichierS,", prelim = %d", NbPrelimv);
	fprintf(fichierS,", generations = %d", NbGenv);
	fprintf(fichierS,", paspr = %d", pasprv);
	fprintf(fichierS,", pas = %d", pasv);
	fprintf(fichierS,", sampleS = %d", sampleSv);
}
